/* THPSMOTD by Andrew "CHCNiZ" Learn 
 * Copyright (C) 2010 Andrew Learn
 *
 *  THPSMOTD is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  THPSMOTD is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with THPSMOTD.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <windows.h>
#include <malloc.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>
#pragma warning(disable:4996)
#pragma warning(disable:4267)
#include "stdint.h"
#include "crc32.h"
#include "motd.h"
#include "resource.h"
enum ControlCrap {
	Button1=1,
	Button2,
	ButtonSave,
	ButtonTHPS,
	ButtonTHUG,
	EditBox,
	IpBox,//the box for typing server/ip to resolve and use in THPS3 MOTD's
};
HWND hMainWnd;
HWND button,button2,button3,buttonthps,buttonthug,editbox,ipbox;
OPENFILENAME ofn;
char szFileName[MAX_PATH] = "",input[1024];
int type=0,game=0;
unsigned long find_length(FILE *fd) {
	unsigned long res,fp;
	if(fd==NULL) return -1;
	fp=ftell(fd);
	fseek(fd,0,SEEK_END);
	res=ftell(fd);
	fseek(fd,fp,SEEK_SET);
	return res;
		}
LRESULT WINAPI WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine,int nShow) {
	MSG msg;
	HWND hMainWnd;
   WNDCLASSEX wc = {sizeof(WNDCLASSEX), CS_VREDRAW|CS_HREDRAW|CS_OWNDC,
                    WndProc, 0, 0, hInstance, LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1)), NULL, (HBRUSH)COLOR_APPWORKSPACE+1,
                    NULL, "THPSMOTD2.0", NULL};
   RegisterClassEx(&wc);
   hMainWnd = CreateWindow("THPSMOTD2.0","THPSMOTD",WS_OVERLAPPEDWINDOW, 100, 100, 300, 230,NULL, NULL, hInstance, NULL);
	   	   button = CreateWindow(
           "BUTTON", /* this makes a "button" */
           "Create", /* this is the text which will appear in the button */
          BS_RADIOBUTTON | WS_VISIBLE | WS_CHILD,
           190, /* these four lines are the position and dimensions of the button */
           5,
           105,
           30,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)Button1, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
	button2 = CreateWindow(
           "BUTTON", /* this makes a "button" */
           "Read", /* this is the text which will appear in the button */
          BS_RADIOBUTTON | WS_VISIBLE | WS_CHILD,
           190, /* these four lines are the position and dimensions of the button */
           35,
           105,
           30,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)Button2, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
	button3 = CreateWindow(
           "BUTTON", /* this makes a "button" */
           "Save", /* this is the text which will appear in the button */
         WS_VISIBLE | WS_CHILD,
           180, /* these four lines are the position and dimensions of the button */
           160,
           105,
           30,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)ButtonSave, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
	buttonthps = CreateWindow(
           "BUTTON", /* this makes a "button" */
           "PRE-THUG2", /* this is the text which will appear in the button */
         BS_RADIOBUTTON|WS_VISIBLE | WS_CHILD,
           80, /* these four lines are the position and dimensions of the button */
           35,
           105,
           30,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)ButtonTHPS, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
		buttonthug = CreateWindow(
           "BUTTON", /* this makes a "button" */
           "THUG2+", /* this is the text which will appear in the button */
			BS_RADIOBUTTON|WS_VISIBLE | WS_CHILD,
           80, /* these four lines are the position and dimensions of the button */
           5,
           105,
           30,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)ButtonTHUG, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
	editbox = CreateWindow(
           "EDIT", /* this makes a "button" */
           "Default Text", /* this is the text which will appear in the button */
         ES_AUTOVSCROLL |ES_MULTILINE |WS_VISIBLE | WS_CHILD|WS_BORDER ,
           5, /* these four lines are the position and dimensions of the button */
           75,
           285,
           80,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)EditBox, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
	ipbox = CreateWindow(
           "EDIT", /* this makes a "button" */
           "master.gamespy.com", /* this is the text which will appear in the button */
         ES_AUTOVSCROLL |ES_MULTILINE |WS_VISIBLE | WS_CHILD|WS_BORDER ,
           5, /* these four lines are the position and dimensions of the button */
           165,
           150,
           20,
           hMainWnd, /* this is the buttons parent window */
           (HMENU)IpBox, /* these next two lines pretty much tell windows what to do when the button is pressed */
           hInstance,
           NULL);
	ShowWindow (button, SW_SHOWNORMAL);
	ShowWindow (button2, SW_SHOWNORMAL);
	ShowWindow (button3, SW_SHOWNORMAL);
	ShowWindow (buttonthug, SW_SHOWNORMAL);
	ShowWindow (buttonthps, SW_SHOWNORMAL);
    SendMessage (button, BM_SETCHECK, TRUE, 0);
	SendMessage (buttonthug, BM_SETCHECK, TRUE, 0);
	Edit_Enable(ipbox,0);
	ShowWindow(hMainWnd, nShow);
	UpdateWindow(hMainWnd);
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
	      DispatchMessage(&msg);
	}
	return(0);
}
LRESULT WINAPI WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	THPSMOTD *motd;
	FILE *fd;
	char buff[1024];
	char filesave[256];
	char input[1024],input2[1024];
   switch(msg)
   {
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			case Button1:
					type=1;
					Edit_Enable(editbox,1);
					if(game!=0)
					Edit_Enable(ipbox,1);
					SetWindowText(button3,"Save");
				    SendMessage (button, BM_SETCHECK, TRUE, 0);
                    SendMessage (button2, BM_SETCHECK, FALSE, 0);
				break;
			case Button2:
					type=2;
					Edit_Enable(editbox,0);
					Edit_Enable(ipbox,0);
					SetWindowText(button3,"Open");
				    SendMessage (button2, BM_SETCHECK, TRUE, 0);
                    SendMessage (button, BM_SETCHECK, FALSE, 0);
				break;
			case ButtonTHPS:
					game=1;
					if(type!=2)
					Edit_Enable(ipbox,1);
				    SendMessage (buttonthps, BM_SETCHECK, TRUE, 0);
                    SendMessage (buttonthug, BM_SETCHECK, FALSE, 0);
				break;
			case ButtonTHUG:
					game=0;
					if(type!=2)
					Edit_Enable(ipbox,0);
				    SendMessage (buttonthps, BM_SETCHECK, FALSE, 0);
                    SendMessage (buttonthug, BM_SETCHECK, TRUE, 0);
				break;
			case ButtonSave:
		ZeroMemory(&ofn, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hMainWnd;
		ofn.lpstrFilter = "THPS MOTD File (*.dat, *txt)\0*.dat;*.txt\0All Files (*.*)\0*.*\0\0";
		ofn.lpstrFile = szFileName;
		ofn.nMaxFile = MAX_PATH;
		ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
		ofn.lpstrInitialDir = NULL;
				if(type!=2) { //save
		ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
		if(GetSaveFileName(&ofn)) { strcpy(filesave,szFileName); } else break; //no error because it happens when you hit cancel
			motd=(THPSMOTD *)malloc(sizeof(THPSMOTD));
			memset(motd,0,sizeof(THPSMOTD));
			motd->window=hMainWnd;
			if(motd==NULL) {
				MessageBox(hMainWnd,"Error allocating memory!","Error",MB_OK|MB_ICONERROR);
				break;
			}
			fd=fopen(filesave,"wb");
			if(!fd) {
				MessageBox(hMainWnd,"Couldn't open file!","Error",MB_OK|MB_ICONERROR);
				break;
			}
			/*
			motd->msg=(uint8_t*)malloc(1024);
			if(motd->msg==NULL) {
				MessageBox(hMainWnd,"Error allocating memory!","Error",MB_OK|MB_ICONERROR);
				break;
			}*/
			Edit_GetText(editbox,input,1024);
			motd->msg=(uint8_t*)&input;
			Edit_GetText(ipbox,input2,1024);
			motd->host=(uint8_t*)&input2;
			gen_motd(motd,game);
			if(motd->errcode!=THPSERR_SUCCESS) {
				show_errcode(motd->errcode,hMainWnd);
			}
			fwrite(motd->fbuff,motd->size,1,fd);
			free(motd->fbuff);
			free(motd);
			fclose(fd);
				} else {//open
					if(GetOpenFileName(&ofn)) { strcpy(filesave,szFileName); } else	break; //no error message because it also happend when you hit cancel
					fd=fopen(filesave,"rb");
					if(!fd) {
						MessageBox(hMainWnd,"Couldn't open file!","Error",MB_OK|MB_ICONERROR);
						break;
					}
						motd=(THPSMOTD *)malloc(sizeof(THPSMOTD));
						if(motd==NULL) {
							MessageBox(hMainWnd,"Error allocating memory!","Error",MB_OK|MB_ICONERROR);
							break;
						}
						motd->size=find_length(fd);
						if(motd->size==-1) {
							MessageBox(hMainWnd,"Failed getting file size!","Error",MB_OK|MB_ICONERROR);
							return 1;
						}
					motd->fbuff=(uint8_t *)malloc(motd->size+1); //Plus one because the end byte of msg must be null terminated
					if(motd->fbuff==NULL) {
						MessageBox(hMainWnd,"Failed allocating memory for file buffer!","Error",MB_OK|MB_ICONERROR);
						return 1;
				}
				fread(motd->fbuff,motd->size,1,fd);
				read_motd(motd,game);
				if(motd->errcode!=THPSERR_SUCCESS) {
					show_errcode(motd->errcode,hMainWnd);
					return 1;
				}
				if(game==0) {
					sprintf(buff,"Message: %s\r\nSize: %i\r\nChecksum: 0x%08X\r\n",motd->msg,motd->size,motd->checksum);
				} else {
				struct in_addr addr;
				addr.S_un.S_addr=motd->size;
				sprintf(buff,"Message: %s\r\nMessage Checksum: 0x%08X\r\nMaster Server IP: %s\r\n",motd->msg,motd->size,inet_ntoa(addr));
				}
				Edit_SetText(editbox,buff);
				free((uint8_t *)motd->fbuff);
				free((THPSMOTD *)motd);
				fclose(fd);

				}
				break;
			}
			break;
      case WM_DESTROY:
         PostQuitMessage(0);
         return(0);
   }
   return(DefWindowProc(hwnd, msg, wParam, lParam));
}